#include <stdio.h>
#include <stdlib.h>

#include "fileoutput.h"

#define THRESHOLD 50

/* 

Anaglyph - Copyright 2004 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://ringtonetools.mikekohn.net/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

int colors[256];

void read_bitmap_file(FILE *in, struct _bitmap_file *bitmap_file)
{
  bitmap_file->bfType[0]=getc(in);
  bitmap_file->bfType[1]=getc(in);
  bitmap_file->bfSize=read_long(in);
  bitmap_file->reserved1=read_word(in);
  bitmap_file->reserved2=read_word(in);
  bitmap_file->bfOffs=read_long(in);
}

void read_bitmap_info(FILE *in, struct _bitmap_info *bitmap_info)
{
  bitmap_info->biSize=read_long(in);
  bitmap_info->biWidth=read_long(in);
  bitmap_info->biHeight=read_long(in);
  bitmap_info->biPlanes=read_word(in);
  bitmap_info->biBitCount=read_word(in);
  bitmap_info->biCompression=read_long(in);
  bitmap_info->biSizeImage=read_long(in);
  bitmap_info->biXPelsPerMetre=read_long(in);
  bitmap_info->biYPelsPerMetre=read_long(in);
  bitmap_info->biClrUsed=read_long(in);
  bitmap_info->biClrImportant=read_long(in);
}

#ifdef DEBUG
void display_bmp_info(int count, struct _bitmap_file *bitmap_file, struct _bitmap_info *bitmap_info)
{
  printf("Bitmap File Header %d\n",count);
  printf("----------------------------------------------\n");
  printf("         bfType: %c%c\n",bitmap_file->bfType[0],bitmap_file->bfType[1]);
  printf("         bfSize: %d\n",bitmap_file->bfSize);
  printf("      reserved1: %d\n",bitmap_file->reserved1);
  printf("      reserved2: %d\n",bitmap_file->reserved2);
  printf("         bfOffs: %d\n",bitmap_file->bfOffs);
  printf("----------------------------------------------\n");
  printf("Bitmap Info Header %d\n",count);
  printf("----------------------------------------------\n");
  printf("         biSize: %d\n",bitmap_info->biSize);
  printf("        biWidth: %d\n",bitmap_info->biWidth);
  printf("       biHeight: %d\n",bitmap_info->biHeight);
  printf("       biPlanes: %d\n",bitmap_info->biPlanes);
  printf("     biBitCount: %d\n",bitmap_info->biBitCount);
  printf("  biCompression: %d\n",bitmap_info->biCompression);
  printf("    biSizeImage: %d\n",bitmap_info->biSizeImage);
  printf("biXPelsPerMetre: %d\n",bitmap_info->biXPelsPerMetre);
  printf("biYPelsPerMetre: %d\n",bitmap_info->biYPelsPerMetre);
  printf("      biClrUsed: %d\n",bitmap_info->biClrUsed);
  printf(" biClrImportant: %d\n",bitmap_info->biClrImportant);
  printf("----------------------------------------------\n");
}
#endif

void raw_uncompressed(FILE *out, FILE *in0, FILE *in1, struct _bitmap_info *bitmap_info)
{
int x,y;
int c0,c1,t;
int byte_count;

  for (y=0; y<bitmap_info->biHeight; y++)
  {
    byte_count=0;

    for (x=0; x<bitmap_info->biWidth; x++)
    {
      if (bitmap_info->biBitCount==8 || bitmap_info->biBitCount==24)
      {
        if (bitmap_info->biBitCount==8) 
        {
          c0=getc(in0);
          c0=colors[c0];
          c1=getc(in1);
          c1=colors[c1];
          byte_count++;
        }
          else
        if (bitmap_info->biBitCount==24)
        {
          c0=(getc(in0)+getc(in0)+getc(in0))/3;
          c1=(getc(in1)+getc(in1)+getc(in1))/3;
          byte_count=byte_count+3;
        }

        write_bmp_pixel(out,c0,c1);
      }
        else
      if (bitmap_info->biBitCount==4)
      {
        c0=getc(in0);
        c1=getc(in1);
        byte_count++;

        write_bmp_pixel(out,colors[((c0>>4)&15)],colors[((c1>>4)&15)]);
        write_bmp_pixel(out,colors[(c0&15)],colors[(c1&15)]);
        x++;
      }
        else
      if (bitmap_info->biBitCount==1)
      {
        c0=getc(in0);
        c1=getc(in1);
        byte_count++;

        for (t=7; t>=0; t--)
        {
          write_bmp_pixel(out,((c0>>t)&1),((c1>>t)&1));

/*
          if (((c>>t)&1)==0)
          { picture[ptr++]=' '; }
            else
          { picture[ptr++]='*'; }
*/
        }

        x=x+7;
      }
    }

    while ((byte_count%4)!=0)
    {
      byte_count++;
      getc(in0);
      getc(in1);
    }
  }
}

void raw_compressed8(FILE *out, FILE *in0, FILE *in1, struct _bitmap_info *bitmap_info)
{
/*
int x,y;
int c,t,r;

  for (y=0; y<bitmap_info->biHeight; y++)
  {
    xout=0;
    x=0;
    while(x<10000)
    {
      c=getc(in);
      if (c==EOF) return;

      if (c!=0)
      {
        r=getc(in);

        for (t=0; t<c; t++)
        {
          if (xout<width)
          {
            if (colors[r]<THRESHOLD)
            { picture[ptr++]=' '; }
              else
            { picture[ptr++]='*'; }
            xout++;
          }
        }

        x=x+c;
      }
        else
      {
        r=getc(in);

        if (r==0)
        {
          break;
        }
          else
        if (r==1)
        {
          return;
        }
          else
        if (r==2)
        {
          x=getc(in);
          y=getc(in);
          xout=x;
          yout=y;
          return;
        }

        for (t=0; t<r; t++)
        {
          c=getc(in);
          if (xout<width)
          {
            if (colors[c]<THRESHOLD)
            { picture[ptr++]=' '; }
              else
            { picture[ptr++]='*'; }
            xout++;
          }
        }

        x=x+r;
      }
    }
  }
*/
}

/*
int parse_bitmap(FILE *in, int width, int height, char *picture)
{
struct _bitmap_file bitmap_file;
struct _bitmap_info bitmap_info;
int t,c;

  read_bitmap_file(in, &bitmap_file);

  if (bitmap_file.bfType[0]!='B' || bitmap_file.bfType[1]!='M')
  {
    printf("Not a bitmap.\n");
    return -1;
  }

  read_bitmap_info(in, &bitmap_info);


  colors[1]=255;
  colors[255]=255;

  for (t=0; t<bitmap_info.biClrImportant; t++)
  {
    c=(getc(in)+getc(in)+getc(in))/3;
    getc(in);
    colors[t]=c;
  }

  c=width*height;
  for (t=0; t<c; t++) picture[t]=' ';

  fseek(in,bitmap_file.bfOffs,0);

  if (bitmap_info.biCompression==0)
  {
    raw_uncompressed(in,width,height,bitmap_info.biWidth,bitmap_info.biHeight,picture,bitmap_info.biBitCount);
  }
    else
  if (bitmap_info.biCompression==1)
  {
    // raw_compressed8(in,width,height,bitmap_info.biWidth,bitmap_info.biHeight,picture,bitmap_info.biBitCount);
    printf("RLE8 compression is not supported at this time.\n");
  }
    else
  if (bitmap_info.biCompression==2)
  {
    printf("RLE4 compression is not supported at this time.\n");
  }
    else
  {
    printf("This type of compression is not supported at this time.\n");
  }

  return 0;
}
*/

